class Lista extends Cola{ //  Implementando Lista a partir de Cola
    private Nodo shadow;
    public Lista(){
        super();
        shadow = null;
    }

    /* el mtodo existe() tiene una doble funcionalidad:
    1) retorna
        true si el  cdigo del item parmetro existe
        false en caso contrario

    2) inicializa la referencia shadow

            shadow = null cuando:
                la lista est vacia
                el cdigo del item parmetro es menor al del primer nodo
                el codigo parametro = codigo nodo en el primer nodo

            shadow = sombra (sombra es el puntero que sique "pegado" a ptr)
                el cdigo nodo  = cdigo parmetro, no en el primer nodo
                el cdigo nodo  > cdigo parmetro
                el cdigo parmetro supera al del ltimo nodo          */

    
    protected boolean existe(int codPar){
        boolean exis = false;       // A priori, suponemos no existe
        Nodo ptr = frente; // Puntero para recorrer la lista.
        Nodo sombra = frente; // Puntero sombra, ir siempre atras de ptr
        int codNod;
        if (vacia())        //  La lista no tiene nodos
            shadow = null;
        else{               //  Tenemos una lista con nodos
            for(;ptr!=null;sombra = ptr, ptr = ptr.getProx()){
                codNod = ptr.getItem().getCodigo();
                if(codNod == codPar){ // hemos encontrado igual, basta de buscar ...
                    exis = true; // existencia verdadera ...
                    if(ptr == frente)   // ptr apunta al primer nodo,
                        shadow = null; // cdigo parmetro es == que el del 1er nodo
                    else            // ptr apunta a un nodo intermedio o final,
                        shadow = sombra;// Referenciamos la posicion del nodo anterior
                    break;
                }     //  if(codNod == codPar)
                if(codNod > codPar){ // ya no vamos a encontrar igual, basta de nuevo
                    if(ptr == frente)   // ptr apunta al primer nodo,
                        shadow = null; // cdigo parmetro es < que el del 1er nodo
                    else            // ptr apunta a un nodo intermedio o final,
                        shadow = sombra;// Referenciamos la posicion del nodo anterior
                    break;
                }     // if(codNod > codPar
            }  // for
            if(ptr == null)  // Recorrimos lista completa, codPar es mayor al del ltimo nodo
                shadow = sombra; //  Referenciamos la posicion del ltimo nodo
        }   // else if (vacia())
        return exis;
    }
    
    protected void inclOrd(int codPar, float vlr){ //   Inserta nodos. Lista ordenada por cdigo.
        Nodo ptr;
        boolean exist = existe(codPar);
        if(exist){  // ya tenemos ese cdigo, no podemos incluirlo nuevamente
            if(trace)System.out.println("inclOrd(), codigo " + codPar + " ya existe");
        }else{      // No existe el cdigo del item parmetro, podemos incluir
            if(shadow != null){     // es una insercin entre nodos o al fin de la lista
                ptr = shadow.getProx(); // obtenemos el puntero al prximo
                shadow.setProx(new Nodo(codPar,vlr,ptr));
                if(ptr == null)
                    fondo = shadow.getProx();
                if(trace) System.out.println("inclOrd() " + codPar + " incluido");
            }else       // Es una insercin al inicio de la lista o la lista est vaca
                inclFirst(codPar, vlr);// usamos el mtodo adecuado, el heredado
        }   // else del if(exist)
    }
    
    protected Nodo exclOrd(int codigo){ //Excluye nodos.Lista ordenada por cdigo
        Nodo ptr;           // para puntero al nodo
        boolean exist = existe(codigo);  // Verificamos su existencia
        Nodo nodo = null;       // Lo necesitamos para almacenar el nodo excluido
        if(exist)       // Tenemos igual codigo en lista, entonces podemos excluir
            if(shadow != null){    // Debemos excluir un nodo intermedio o final
                nodo = shadow.getProx(); // puntero al nodo a excluir
                ptr  = nodo.getProx();   // puntero al siguiente al excluido
                shadow.setProx(ptr);    // Vinculamos anterior al siguiente al excl.
                if(ptr == null)
                    fondo = shadow;
                if(trace) System.out.println("exclOrd(), codigo " + codigo + " excluido");
            }else                           // El nodo a excluir es el primero
                nodo = exclFirst();     // usamos el mtodo adecuado, el heredado
                if(trace) System.out.print("exclFirst(), codigo " + codigo + " excluido");
        else        // No existe el item buscado
            if(trace) System.out.print("exclOrd(), codigo " + codigo + " no existe");
        return nodo;                // retornamos el nodo excluido completo
    }
    
    
    protected void actValor(int codigo, float val){ // Actualiza valor del item del nodo.
        Nodo ptr;                   // para puntero al nodo
        boolean exist = existe(codigo);       // Verificamos su existencia
        Nodo ptrAct;        // Puntero al nodo cuyo valor de item actualizaremos
        if(exist){      // Tenemos cdigo en lista, podemos actualizar valor asociado
            if(shadow != null)      // Debemos actualizar en un nodo intermedio o final
                ptrAct = shadow.getProx(); // seteamos ptrAct con la direccin correcta
            else            // El valor a actualizar est en el item del primer nodo
                ptrAct = frente;
            // En este punto, ptrAct apunta al nodo cuyo valor queremos actualizar
            Item it = new Item(codigo,val); // Generamos un objeto item  y lo usamos para
            ptrAct.setItem(it);             // reemplazar el del nodo
            if(trace) System.out.println("actValor(), cdigo " + codigo + " a " + val);
        }else                   // No existe el item buscado
            if(trace)System.out.print("actValor(), cdigo " + codigo + " no existe");
    }
    
    protected void implDemo1(){
        System.out.println("implDemo1() class Lista");
        System.out.println("Incluimos 4 nodos - inclFirst()");
        for(int i=4;i>0;--i)inclFirst(i*2,(float)(i*4));
        System.out.println(this);
        System.out.println("Borramos el primero");
        exclFirst();
        System.out.println(this);
        System.out.println("Demo implDemo1() terminado !!!");
    }
    
    protected void implDemo2(){
        System.out.println("implDemo2() class Lista");
        System.out.println("Incluimos 4 nodos - inclOrd()");
        for(int i=1;i<5;++i)inclOrd(i*2+1,(float)(i*4.2));
        System.out.println(this);
        System.out.println("Borramos el primero");
        exclFirst();
        System.out.println("Borramos el cdigo 7");
        exclOrd(7);
        System.out.println(this);
        System.out.println("Demo implDemo2() terminado !!!");
    }

    protected void implDemo3(){
        System.out.println("implDemo3() class Lista");
        System.out.println("Incluimos 3 nodos - inclFirst()");
        for(int i=4;i>1;--i)inclFirst(i*2,(float)(i*4));
        System.out.println(this);
        System.out.println("Incluimos 4 nodos - inclOrd()");
        for(int i=1;i<5;++i)inclOrd(i*2+1,(float)(i*4.2));
        System.out.println(this);
        System.out.println("Demo implDemo3() terminado !!!");
    }

    protected void implDemo4(){
        System.out.println("implDemo4() class Lista");
        System.out.println("Incluimos 5 nodos - inclOrd()");
        for(int i=1;i<6;++i)inclOrd(i*2+1,(float)(i*4.2));
        System.out.println(this);
        System.out.println("Borraremos el codigo 5");
        exclOrd(5);
        System.out.println("Borraremos el cdigo 9");
        exclOrd(9);
        System.out.println("Borraremos el cdigo 8 ");
        exclOrd(8);
        System.out.println(toString());
        System.out.println("Demo implDemo4() terminado !!!");
    }

    protected void implDemo5(){
        System.out.println("implDemo5() class Lista");
        System.out.println("Incluiremos 3 nodos - inclOrd()");
        for(int i=1;i<4;++i)inclOrd(i*2+1,(float)(i*4.2));
        System.out.println(this);
        System.out.println("Actualizaremos el cdigo 5");
        actValor(5,10);
        System.out.println("Actualizamos el cdigo 3");
        actValor(3,20);
        System.out.println("Actualizamos el cdigo 8");
        actValor(8,20);
        System.out.println(this);
        System.out.println("Demo implDemo5()terminado !!!");
    }
    public static void main(String args[]){
        Lista list = new Lista();
        list.implDemo5();
    }
}


